Index: trunk/src/VBox/Devices/Network/DevPCNet.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 26295)
+++ trunk/src/VBox/Devices/Network/DevPCNet.cpp	(revision 26296)
@@ -2826,5 +2826,5 @@
             }
         case 15: /* Mode */
-            if ((pThis->aCSR[15] & 0x8000) != (val & 0x8000) && pThis->pDrv)
+            if ((pThis->aCSR[15] & 0x8000) != (uint16_t)(val & 0x8000) && pThis->pDrv)
             {
                 Log(("#%d: promiscuous mode changed to %d\n", PCNET_INST_NR, !!(val & 0x8000)));
Index: trunk/src/VBox/Devices/Network/testcase/tstIntNetR0.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/testcase/tstIntNetR0.cpp	(revision 26295)
+++ trunk/src/VBox/Devices/Network/testcase/tstIntNetR0.cpp	(revision 26296)
@@ -560,5 +560,6 @@
                             if (!g_cErrors)
                             {
-                                ARGS Args0 = {0};
+                                ARGS Args0;
+                                RT_ZERO(Args0);
                                 Args0.hIf = hIf0;
                                 Args0.pBuf = pBuf0;
@@ -568,5 +569,6 @@
                                 Args0.Mac.au16[2] = 0;
 
-                                ARGS Args1 = {0};
+                                ARGS Args1;
+                                RT_ZERO(Args1);
                                 Args1.hIf = hIf1;
                                 Args1.pBuf = pBuf1;
Index: trunk/src/VBox/Devices/Storage/testcase/vditool.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/testcase/vditool.cpp	(revision 26295)
+++ trunk/src/VBox/Devices/Storage/testcase/vditool.cpp	(revision 26296)
@@ -112,5 +112,5 @@
         return PrintDone(rc);
 
-    PDMMEDIAGEOMETRY geo = { 0 }; /* auto-detect */
+    PDMMEDIAGEOMETRY geo = { 0, 0, 0 }; /* auto-detect */
     rc = VDCreateBase(hdd, "vdi", pszUtf8Filename,
                       (uint64_t)cMBs * _1M,
Index: trunk/src/VBox/Disassembler/DisasmTest.cpp
===================================================================
--- trunk/src/VBox/Disassembler/DisasmTest.cpp	(revision 26295)
+++ trunk/src/VBox/Disassembler/DisasmTest.cpp	(revision 26296)
@@ -46,5 +46,5 @@
     else
     {
-        RTUINTPTR pInstr = (RTUINTPTR)TestProc;
+        RTUINTPTR pInstr = (uintptr_t)TestProc;
 
         for (int i=0;i<50;i++)
@@ -70,5 +70,5 @@
 #ifndef RT_OS_OS2
         printf("\n64 bits disassembly\n");
-        pInstr = (RTUINTPTR)TestProc64;
+        pInstr = (uintptr_t)TestProc64;
 
 ////__debugbreak();
Index: trunk/src/VBox/Disassembler/DisasmTestCore.cpp
===================================================================
--- trunk/src/VBox/Disassembler/DisasmTestCore.cpp	(revision 26295)
+++ trunk/src/VBox/Disassembler/DisasmTestCore.cpp	(revision 26296)
@@ -44,5 +44,5 @@
         DISCPUSTATE cpu;
         cpu.mode = CPUMODE_32BIT;
-        if (DISCoreOne(&cpu, (RTUINTPTR)&DISCoreOne, &cb))
+        if (DISCoreOne(&cpu, (uintptr_t)&DISCoreOne, &cb))
             printf("ok %d\n", cpu.addrmode);
         else
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIWizard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIWizard.cpp	(revision 26295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIWizard.cpp	(revision 26296)
@@ -47,5 +47,5 @@
 
     /* Calculating nearest 'golden ratio' width. */
-    int iGoldRatioWidth = sqrt(1.61 * width() * height());
+    int iGoldRatioWidth = (int)sqrt(1.61 * width() * height());
     int iNewLabelWidth = iGoldRatioWidth - iLabelDelta;
     resizeAccordingLabelWidth(iNewLabelWidth);
Index: trunk/src/VBox/HostServices/SharedClipboard/x11-clipboard.cpp
===================================================================
--- trunk/src/VBox/HostServices/SharedClipboard/x11-clipboard.cpp	(revision 26295)
+++ trunk/src/VBox/HostServices/SharedClipboard/x11-clipboard.cpp	(revision 26296)
@@ -53,5 +53,5 @@
      * the backend is responsible for ensuring that this does not happen. */
     VBOXCLIPBOARDREQFROMVBOX *pReq;
-    
+
     /** Pointer to the opaque X11 backend structure */
     CLIPBACKEND *pBackend;
@@ -222,5 +222,5 @@
  *         freed in ClipCompleteDataRequestFromX11 when it is called back from
  *         the backend code.
- *         
+ *
  */
 int vboxClipboardReadData (VBOXCLIPBOARDCLIENTDATA *pClient,
@@ -230,5 +230,5 @@
     LogRelFlowFunc(("pClient=%p, u32Format=%02X, pv=%p, cb=%u, pcbActual=%p",
                  pClient, u32Format, pv, cb, pcbActual));
-    
+
     int rc = VINF_SUCCESS;
     CLIPREADCBREQ *pReq = (CLIPREADCBREQ *) RTMemAlloc(sizeof(CLIPREADCBREQ));
@@ -357,5 +357,5 @@
                                    uint32_t *pcb)
 {
-    VBOXCLIPBOARDREQFROMVBOX request = { NULL };
+    VBOXCLIPBOARDREQFROMVBOX request = { NULL, 0, 0, NIL_RTSEMEVENT };
 
     LogRelFlowFunc(("pCtx=%p, u32Format=%02X, ppv=%p, pcb=%p\n", pCtx,
@@ -413,5 +413,5 @@
                 pReq->cb = cb;
                 pReq->format = u32Format;
-            }            
+            }
         }
         /* Signal that the request has been completed. */
Index: trunk/src/VBox/Main/MediumImpl.cpp
===================================================================
--- trunk/src/VBox/Main/MediumImpl.cpp	(revision 26295)
+++ trunk/src/VBox/Main/MediumImpl.cpp	(revision 26296)
@@ -4949,5 +4949,5 @@
             if (FAILED(rc)) throw rc;
 
-            PDMMEDIAGEOMETRY geo = { 0 }; /* auto-detect */
+            PDMMEDIAGEOMETRY geo = { 0, 0, 0 }; /* auto-detect */
 
             vrc = VDCreateBase(hdd,
@@ -5501,5 +5501,5 @@
     ComObjPtr<Medium> &pParent = task.d.parentDisk;
 
-    bool fCreatingTarget;
+    bool fCreatingTarget; /** @todo warning: 'fCreatingTarget' might be used uninitialized in this function */
 
     uint64_t size = 0, logicalSize = 0;
Index: trunk/src/VBox/Main/include/AutoStateDep.h
===================================================================
--- trunk/src/VBox/Main/include/AutoStateDep.h	(revision 26295)
+++ trunk/src/VBox/Main/include/AutoStateDep.h	(revision 26296)
@@ -164,2 +164,3 @@
 
 #endif // ____H_AUTOSTATEDEP
+
Index: trunk/src/VBox/Main/linux/HostHardwareLinux.cpp
===================================================================
--- trunk/src/VBox/Main/linux/HostHardwareLinux.cpp	(revision 26295)
+++ trunk/src/VBox/Main/linux/HostHardwareLinux.cpp	(revision 26296)
@@ -325,38 +325,39 @@
     AssertPtrNullReturn(pchModel, VERR_INVALID_POINTER);
 
-    unsigned char u8Response[96] = { 0 };
-    struct cdrom_generic_command CdromCommandReq =
-    { { INQUIRY, 0, 0, 0, sizeof(u8Response), 0 }  /* INQUIRY */ };
-    int rc, rcIoCtl = 0;
-    RTFILE file;
-    rc = RTFileOpen(&file, pcszNode, RTFILE_O_READ | RTFILE_O_OPEN | RTFILE_O_DENY_NONE | RTFILE_O_NON_BLOCK);
+    RTFILE hFile;
+    int rc = RTFileOpen(&hFile, pcszNode, RTFILE_O_READ | RTFILE_O_OPEN | RTFILE_O_DENY_NONE | RTFILE_O_NON_BLOCK);
     if (RT_SUCCESS(rc))
     {
-        CdromCommandReq.buffer = u8Response;
-        CdromCommandReq.buflen = sizeof(u8Response);
+        int                             rcIoCtl        = 0;
+        unsigned char                   u8Response[96] = { 0 };
+        struct cdrom_generic_command    CdromCommandReq;
+        RT_ZERO(CdromCommandReq);
+        CdromCommandReq.cmd[0]         = INQUIRY;
+        CdromCommandReq.cmd[4]         = sizeof(u8Response);
+        CdromCommandReq.buffer         = u8Response;
+        CdromCommandReq.buflen         = sizeof(u8Response);
         CdromCommandReq.data_direction = CGC_DATA_READ;
-        CdromCommandReq.timeout = 5000;  /* ms */
-        rc = RTFileIoCtl(file, CDROM_SEND_PACKET, &CdromCommandReq, 0,
-                         &rcIoCtl);
+        CdromCommandReq.timeout        = 5000;  /* ms */
+        rc = RTFileIoCtl(hFile, CDROM_SEND_PACKET, &CdromCommandReq, 0, &rcIoCtl);
         if (RT_SUCCESS(rc) && rcIoCtl < 0)
             rc = RTErrConvertFromErrno(-CdromCommandReq.stat);
-        RTFileClose(file);
-    }
-    if (RT_SUCCESS(rc))
-    {
-        if (pu8Type)
-            *pu8Type = u8Response[0] & 0x1f;
-        if (pchVendor)
-            RTStrPrintf(pchVendor, cchVendor, "%.8s",
-                        (char *) &u8Response[8] /* vendor id string */);
-        if (pchModel)
-            RTStrPrintf(pchModel, cchModel, "%.16s",
-                        (char *) &u8Response[16] /* product id string */);
+        RTFileClose(hFile);
+
+        if (RT_SUCCESS(rc))
+        {
+            if (pu8Type)
+                *pu8Type = u8Response[0] & 0x1f;
+            if (pchVendor)
+                RTStrPrintf(pchVendor, cchVendor, "%.8s",
+                            &u8Response[8] /* vendor id string */);
+            if (pchModel)
+                RTStrPrintf(pchModel, cchModel, "%.16s",
+                            &u8Response[16] /* product id string */);
+            LogRelFlowFunc(("returning success: type=%u, vendor=%.8s, product=%.16s\n",
+                            u8Response[0] & 0x1f, &u8Response[8], &u8Response[16]));
+            return VINF_SUCCESS;
+        }
     }
     LogRelFlowFunc(("returning %Rrc\n", rc));
-    if (RT_SUCCESS(rc))
-        LogRelFlowFunc(("    type=%u, vendor=%.8s, product=%.16s\n",
-                        u8Response[0] & 0x1f, (char *) &u8Response[8],
-                        (char *) &u8Response[16]));
     return rc;
 }
@@ -801,5 +802,4 @@
                   pList, (unsigned) isDVD, pfSuccess));
     PRTDIR pDir = NULL;
-    RTDIRENTRY entry = {0};
     int rc;
     bool fSuccess = false;
@@ -813,6 +813,7 @@
     fSuccess = true;
     if (RT_SUCCESS(rc))
-        while (true)
-        {
+        for (;;)
+        {
+            RTDIRENTRY entry;
             rc = RTDirRead(pDir, &entry, NULL);
             Assert(rc != VERR_BUFFER_OVERFLOW);  /* Should never happen... */
@@ -989,6 +990,7 @@
     bool success = false;
 
-    deviceNodeArray aDevices = { { 0 } };
     char szPath[RTPATH_MAX] = "/dev";
+    deviceNodeArray aDevices;
+    RT_ZERO(aDevices);
     devFindDeviceRecursive(szPath, sizeof(szPath), aDevices, isDVD);
     try
Index: trunk/src/VBox/Main/xml/Settings.cpp
===================================================================
--- trunk/src/VBox/Main/xml/Settings.cpp	(revision 26295)
+++ trunk/src/VBox/Main/xml/Settings.cpp	(revision 26296)
@@ -394,14 +394,18 @@
                )
             {
-                RTTIME time = { yyyy,
-                                (uint8_t)mm,
-                                0,
-                                0,
-                                (uint8_t)dd,
-                                (uint8_t)hh,
-                                (uint8_t)min,
-                                (uint8_t)secs,
-                                0,
-                                RTTIME_FLAGS_TYPE_UTC };
+                RTTIME time =
+                {
+                    yyyy,
+                    (uint8_t)mm,
+                    0,
+                    0,
+                    (uint8_t)dd,
+                    (uint8_t)hh,
+                    (uint8_t)min,
+                    (uint8_t)secs,
+                    0,
+                    RTTIME_FLAGS_TYPE_UTC,
+                    0
+                };
                 if (RTTimeNormalize(&time))
                     if (RTTimeImplode(&timestamp, &time))
Index: trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp	(revision 26295)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp	(revision 26296)
@@ -126,5 +126,5 @@
                         memset(&Cpu, 0, sizeof(Cpu));
                         Cpu.mode = CPUMODE_32BIT;
-                        if (MyDisBlock(&Cpu, (RTUINTPTR)pvBits + off, 200, Addr - (uintptr_t)pvBits))
+                        if (MyDisBlock(&Cpu, (uintptr_t)pvBits + off, 200, Addr - (uintptr_t)pvBits))
                         {
                             RTUINTPTR Addr2 = 0xd0000000;
@@ -132,5 +132,5 @@
                             if (RT_SUCCESS(rc))
                             {
-                                if (MyDisBlock(&Cpu, (RTUINTPTR)pvBits + off, 200, Addr2 - (uintptr_t)pvBits))
+                                if (MyDisBlock(&Cpu, (uintptr_t)pvBits + off, 200, Addr2 - (uintptr_t)pvBits))
                                     rcRet = 0;
                                 else
Index: trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp	(revision 26295)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-3.cpp	(revision 26296)
@@ -199,5 +199,6 @@
             for (int i = 3; i < argc; i++)
             {
-                TESTNEARSYM NearSym = {0};
+                TESTNEARSYM NearSym;
+                RT_ZERO(NearSym);
                 NearSym.Addr = (RTUINTPTR)RTStrToUInt64(argv[i]);
                 NearSym.aSyms[1].Value = ~(RTUINTPTR)0;
Index: trunk/src/VBox/Runtime/testcase/tstRTAvl.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTAvl.cpp	(revision 26295)
+++ trunk/src/VBox/Runtime/testcase/tstRTAvl.cpp	(revision 26296)
@@ -841,5 +841,8 @@
         AVLROGCPHYSTREE     Tree;
         AVLROGCPHYSNODECORE aNode[4];
-    } s1 = {0}, s2 = {0}, s3 = {0};
+    }   s1, s2, s3;
+    RT_ZERO(s1);
+    RT_ZERO(s2);
+    RT_ZERO(s3);
 
     s1.aNode[0].Key        = 0x00030000;
Index: trunk/src/VBox/VMM/PATM/VMMAll/PATMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/VMMAll/PATMAll.cpp	(revision 26295)
+++ trunk/src/VBox/VMM/PATM/VMMAll/PATMAll.cpp	(revision 26296)
@@ -391,5 +391,5 @@
             ||  (pRegFrame->cs & X86_SEL_RPL) != 3
             ||  pVM->patm.s.pfnSysEnterPatchGC == 0
-            ||  pVM->patm.s.pfnSysEnterGC != (RTRCPTR)pCtx->SysEnter.eip
+            ||  pVM->patm.s.pfnSysEnterGC != (RTRCPTR)(RTRCUINTPTR)pCtx->SysEnter.eip
             ||  !(PATMRawGetEFlags(pVM, pRegFrame) & X86_EFL_IF))
             goto end;
Index: trunk/src/VBox/VMM/PATM/VMMGC/CSAMGC.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/VMMGC/CSAMGC.cpp	(revision 26295)
+++ trunk/src/VBox/VMM/PATM/VMMGC/CSAMGC.cpp	(revision 26296)
@@ -91,5 +91,5 @@
         rc = PGMShwModifyPage(pVCpu, pvFault, 1, X86_PTE_RW, ~(uint64_t)X86_PTE_RW);
         AssertMsgRC(rc, ("PGMShwModifyPage -> rc=%Rrc\n", rc));
-        ASMInvalidatePage((void *)pvFault);
+        ASMInvalidatePage((void *)(uintptr_t)pvFault);
         return VINF_SUCCESS;
     }
@@ -121,6 +121,6 @@
 
     /* Note that pvFault might be a different address in case of aliases. So use pvRange + offset instead!. */
-    pVM->csam.s.pvDirtyBasePage[pVM->csam.s.cDirtyPages] = (RTRCPTR)((RTGCUINTPTR)pvRange + offRange);
-    pVM->csam.s.pvDirtyFaultPage[pVM->csam.s.cDirtyPages] = (RTRCPTR)((RTGCUINTPTR)pvRange + offRange);
+    pVM->csam.s.pvDirtyBasePage[pVM->csam.s.cDirtyPages] = (RTRCPTR)((RTRCUINTPTR)pvRange + offRange);
+    pVM->csam.s.pvDirtyFaultPage[pVM->csam.s.cDirtyPages] = (RTRCPTR)((RTRCUINTPTR)pvRange + offRange);
     if (++pVM->csam.s.cDirtyPages == CSAM_MAX_DIRTY_PAGES)
         return VINF_CSAM_PENDING_ACTION;
@@ -132,5 +132,5 @@
     rc = PGMShwModifyPage(pVCpu, pvFault, 1, X86_PTE_RW, ~(uint64_t)X86_PTE_RW);
     AssertMsgRC(rc, ("PGMShwModifyPage -> rc=%Rrc\n", rc));
-    ASMInvalidatePage((void *)pvFault);
+    ASMInvalidatePage((void *)(uintptr_t)pvFault);
 
     STAM_COUNTER_INC(&pVM->csam.s.StatCodePageModified);
Index: trunk/src/VBox/VMM/PATM/VMMGC/PATMGC.cpp
===================================================================
--- trunk/src/VBox/VMM/PATM/VMMGC/PATMGC.cpp	(revision 26295)
+++ trunk/src/VBox/VMM/PATM/VMMGC/PATMGC.cpp	(revision 26296)
@@ -63,5 +63,5 @@
 VMMRCDECL(int) PATMGCMonitorPage(PVM pVM, RTGCUINT uErrorCode, PCPUMCTXCORE pRegFrame, RTGCPTR pvFault, RTGCPTR pvRange, uintptr_t offRange)
 {
-    pVM->patm.s.pvFaultMonitor = (RTRCPTR)pvFault;
+    pVM->patm.s.pvFaultMonitor = (RTRCPTR)(RTRCUINTPTR)pvFault;
     return VINF_PATM_CHECK_PATCH_PAGE;
 }
@@ -92,6 +92,6 @@
     STAM_PROFILE_ADV_START(&pVM->patm.s.StatPatchWriteDetect, a);
 
-    pWritePageStart = (RTGCUINTPTR)GCPtr & PAGE_BASE_GC_MASK;
-    pWritePageEnd   = ((RTGCUINTPTR)GCPtr + cbWrite - 1) & PAGE_BASE_GC_MASK;
+    pWritePageStart = (RTRCUINTPTR)GCPtr & PAGE_BASE_GC_MASK;
+    pWritePageEnd   = ((RTRCUINTPTR)GCPtr + cbWrite - 1) & PAGE_BASE_GC_MASK;
 
     pPatchPage = (PPATMPATCHPAGE)RTAvloU32Get(CTXSUFF(&pVM->patm.s.PatchLookupTree)->PatchTreeByPage, (AVLOU32KEY)pWritePageStart);
@@ -110,5 +110,5 @@
     if (pPatchPage)
     {
-        if (    pPatchPage->pLowestAddrGC  > (RTRCPTR)((RTGCUINTPTR)GCPtr + cbWrite - 1)
+        if (    pPatchPage->pLowestAddrGC  > (RTRCPTR)((RTRCUINTPTR)GCPtr + cbWrite - 1)
             ||  pPatchPage->pHighestAddrGC < (RTRCPTR)GCPtr)
         {
@@ -516,5 +516,5 @@
                 return VINF_EM_RAW_EMULATE_INSTR;
             }
-            rc = DISCoreOne(&cpu, (RTUINTPTR)&pRec->patch.aPrivInstr[0], &cbOp);
+            rc = DISCoreOne(&cpu, (uintptr_t)&pRec->patch.aPrivInstr[0], &cbOp);
             if (RT_FAILURE(rc))
             {
Index: trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp	(revision 26295)
+++ trunk/src/VBox/VMM/VMMR0/HWVMXR0.cpp	(revision 26296)
@@ -2262,5 +2262,5 @@
     int         rc = VINF_SUCCESS;
     RTGCUINTREG val;
-    RTGCUINTREG exitReason = VMX_EXIT_INVALID;
+    RTGCUINTREG exitReason = (RTGCUINTREG)VMX_EXIT_INVALID;
     RTGCUINTREG instrError, cbInstr;
     RTGCUINTPTR exitQualification = 0;
Index: trunk/src/VBox/VMM/testcase/tstCompiler.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstCompiler.cpp	(revision 26295)
+++ trunk/src/VBox/VMM/testcase/tstCompiler.cpp	(revision 26296)
@@ -201,5 +201,5 @@
 {
     RTPrintf("tstBitFields: Disassembly of %s:\n", pszName);
-    RTUINTPTR uCur = (RTUINTPTR)pv;
+    RTUINTPTR uCur = (uintptr_t)pv;
     RTUINTPTR uCurMax = uCur + 256;
     DISCPUSTATE Cpu;
@@ -218,5 +218,5 @@
         else
         {
-            RTPrintf("tstBitFields: %p: %02x - DISInstr failed!\n", uCur, *(uint8_t *)uCur);
+            RTPrintf("tstBitFields: %p: %02x - DISInstr failed!\n", uCur, *(uint8_t *)(uintptr_t)uCur);
             uCur += 1;
         }